<?php
include('lib/mysqlfs.php');
$sqlfs=new mysqlfs(new mysqli('localhost','root','','sqlfs_v2'),'index');
$sqlfs->setuser('admin',9); //User admin, group 9
$sqlfs->valid_user('return true;'); //Allow every username
if(!isset($_GET['path'])) $_GET['path']='/';
$show_dir=false;
$show_file=false;
if(isset($_GET['action'])) {
	if($_GET['action']=="delete") {
		if($sqlfs->is_dir($_GET['path'])) {
			if($sqlfs->rmdir($_GET['path'])) {
				echo "Map gewist";
			}
			else {
				echo "Fout bij map wissen";
			}

		}
		else {
			if($sqlfs->unlink($_GET['path'])) {
				echo "Bestand gewist";
			}
			else {
				echo "Fout bij bestand wissen";
			}
		}
	$_GET['path']=dirname($_GET['path']);
	$show_dir=true;
	}
	if($_GET['action']=="new") {
		if($_GET['type']=="d") {
			if(!$sqlfs->file_exists($_GET['path'].'/'.$_GET['name'])) {
				if($sqlfs->mkdir($_GET['path'].'/'.$_GET['name'])) {
					echo "Map aangemaakt";
				}
				else {
					echo "Fout bij map aanmaken";
				}
			}
			else {
				echo "Bestand bestaat al";
			}
		$show_dir=true;
		}
		else {
			if(!$sqlfs->file_exists($_GET['path'].'/'.$_GET['name'])) {
				if($sqlfs->mkfile($_GET['path'].'/'.$_GET['name'])) {
					echo "Bestand aangemaakt";
				}
				else {
					echo "Fout bij bestand aanmaken";
				}
			}
			else {
				echo "Bestand bestaat al";
			}
		$show_dir=true;
		}
	}
	if($_GET['action']=="edit") {
		if($sqlfs->is_file($_GET['path'])&&!isset($_POST['abort'])) {
			if(isset($_POST['content'])) {
				if($sqlfs->file_put_contents($_GET['path'],$_POST['content'])) {
					echo "Bestand opgeslaan";
				}
				else {
					echo "Fout bij bestand opslaan";
				}
			}
			echo "
			<form action='?action=edit&path={$sqlfs->simplify_path($_GET['path'])}' method='POST'>
			<textarea name='content' style='width: 100%;height: 90%'>".htmlentities($sqlfs->file_get_contents($_GET['path']))."</textarea>
			<input type='submit' style='width: 50%;height: 10%'><input type='submit' style='width: 50%;height: 10%' name='abort' value='Annuleren'>
			</form>
			";
			$show_dir=false;
			$show_file=false;
		}
		else {
			if(!isset($_POST['abort'])) {
				echo "Het opgegeven pad is geen bestand!";
			}
			else {
				$_GET['path']=dirname($_GET['path']);
			}
			$show_dir=true;
		}
	}
	else if($_GET['action']=="chmod") {
		if(isset($_POST['mod'])) {
			if($sqlfs->chmod($_GET['path'],$_POST['mod'])) {
				echo "Bestand chmodded";
			}
			else {
				echo "Fout bij bestand chmodden";
			}
		}
		else {
			echo "
			<form action='?action=chmod&path={$sqlfs->simplify_path($_GET['path'])}' method='POST'>
			<input type='text' value='{$sqlfs->getinfo($_GET['path'],'rights')}' name='mod'>
			<input type='submit'>
			</form>
			";
		}
		$_GET['path']=dirname($_GET['path']);
		$show_dir=true;
	}
	else if($_GET['action']=="chown") {
		if(isset($_POST['user'])) {
			if($sqlfs->chown($_GET['path'],$_POST['user'])) {
				echo "Bestand chowned";
			}
			else {
				echo "Fout bij bestand chownen";
			}
		}
		else {
		echo "
			<form action='?action=chown&path={$sqlfs->simplify_path($_GET['path'])}' method='POST'>
			<input type='text' value='{$sqlfs->getinfo($_GET['path'],'owner')}' name='user'>
			<input type='submit'>
			</form>
			";
		}
		$_GET['path']=dirname($_GET['path']);
		$show_dir=true;
	}
	else if($_GET['action']=="chgrp") {
		if(isset($_POST['grp'])) {
			if($sqlfs->chgrp($_GET['path'],(int)$_POST['grp'])) {
				echo "Bestand chgrped";
			}
			else {
				echo "Fout bij bestand chgrpen";
			}
		}
		else {
		echo "
			<form action='?action=chgrp&path={$sqlfs->simplify_path($_GET['path'])}' method='POST'>
			<input type='text' value='{$sqlfs->getinfo($_GET['path'],'group')}' name='grp'>
			<input type='submit'>
			</form>
			";
		}
		$_GET['path']=dirname($_GET['path']);
		$show_dir=true;
	}
	else if($_GET['action']=="upload") {
		// Check if a file has been uploaded
		if(isset($_FILES['file'])) {
			// Make sure the file was sent without errors
			if($_FILES['file']['error'] == 0) {
				//Move uploaded file
				if($sqlfs->move_uploaded_file($_FILES['file']['tmp_name'],$_GET['path'].'/'.$_FILES['file']['name'])) {
					echo "Bestand geupload";
				}
				else {
					echo "Fout bij bestand aanmaken";
				}
			}
			else {
				echo 'Fout bij bestand verzenden';
			}
		}
		$show_dir=true;
	}
	else if($_GET['action']=="rename") {
		if(isset($_POST['newname'])) {
			if($sqlfs->rename($_GET['path'],$_POST['newname'])){
				echo "Bestand verplaatst";
			}
			else {
				echo "Fout bij bestand verplaatsen";
			}
		}
		else {
			echo "
			<form action='?action=rename&path={$sqlfs->simplify_path($_GET['path'])}' method='POST'>
			<input type='text' value='{$_GET['path']}' name='newname'>
			<input type='submit'>
			</form>
			";
		}
	$_GET['path']=dirname($_GET['path']);
	$show_dir=true;
	}
	else if($_GET['action']=="copy") {
		if(isset($_POST['dest'])) {
			if($sqlfs->copy($_GET['path'],$_POST['dest'])) {
				echo "Bestand gekopi&euml;rd";
			}
			else {
				echo "Fout bij bestand kopi&euml;ren";
			}
		}
		else {
			echo "
				<form action='?action=copy&path={$sqlfs->simplify_path($_GET['path'])}' method='POST'>
				<input type='text' value='{$_GET['path']}' name='dest'>
				<input type='submit'>
				</form>
			";
		}
	$show_dir=true;
	$_GET['path']=dirname($_GET['path']);
	}

}
else if($sqlfs->is_dir($_GET['path'])) {
	$show_dir=true;
}
else if($sqlfs->is_file($_GET['path'])) {
	$show_dir=false;
	$show_file=true;
}

if($show_dir) {
	$dir=$sqlfs->readdir_full($_GET['path']);
	echo "<h1>Index of /{$sqlfs->simplify_path($_GET['path'])}</h1>";
	echo "
	<form action='?' method='GET'>
	<input type='hidden' name='action' value='new'>
	<input type='hidden' name='path' value='{$sqlfs->simplify_path($_GET['path'])}'>
	<select name='type'>
	<option value='d'>Map</option>
	<option value='f'>Bestand</option>
	</select>
	<input type='text' name='name' value=''>
	<input type='submit' value='Aanmaken'>
	</form>
	";
	echo "
	<form action='?action=upload&path={$sqlfs->simplify_path($_GET['path'])}' method='POST' enctype='multipart/form-data'>
	<input type='file' name='file'>
	<input type='submit' value='Upload'>
	</form>
	";
	echo "<table><thead><tr><th>Name</th><th>Rechten</th><th>Owner</th><th>Group</th><th>Bewerkt</th><th>Grootte</th><th>Acties</th></tr><tr><th colspan='5'><hr></th></tr></thead><tbody>";
	foreach($dir as $value) {
		echo "<tr><td>[{$value['type']}] <a href='?path={$sqlfs->simplify_path($_GET['path'])}/{$value['filename']}'>{$value['filename']}</a></td><td>{$value['rights']}</td><td>{$value['owner']}</td><td>{$value['group']}</td><td>{$value['time']}</td><td>{$sqlfs->sizetohuman($value['size'])}</td><td>
			<a href='?path={$sqlfs->simplify_path($_GET['path'])}/{$value['filename']}&action=delete'>Wissen</a>".(($value['type']=='f')?" <a href='?path={$sqlfs->simplify_path($_GET['path'])}/{$value['filename']}&action=edit'>Bewerken</a>":"")." <a href='?path={$sqlfs->simplify_path($_GET['path'])}/{$value['filename']}&action=chmod'>Chmod</a> <a href='?path={$sqlfs->simplify_path($_GET['path'])}/{$value['filename']}&action=chown'>Chown</a> <a href='?path={$sqlfs->simplify_path($_GET['path'])}/{$value['filename']}&action=chgrp'>Chgrp</a> <a href='?path={$sqlfs->simplify_path($_GET['path'])}/{$value['filename']}&action=rename'>Hernoemen</a> <a href='?path={$sqlfs->simplify_path($_GET['path'])}/{$value['filename']}&action=copy'>Kopi&euml;ren</a></td></tr>";
		}
	echo "</tbody></table>";
}
else if($show_file) {
	ob_clean();
	$fileinfo=$sqlfs->getinfo($_GET['path']);
	header("Content-Type: ".$fileinfo['mime']);
	header("Content-Length: ".$fileinfo['size']);
	header("Last-Modified: ".$fileinfo['time']);
	header("Content-Disposition: attachment; filename=\"" . $fileinfo['filename'] . "\"");
	echo $sqlfs->file_get_contents($_GET['path']);
}
?>